clear all
close all
clc

%% punto 1)
%Si ricavino (a mano) le equazioni del sistema dinamico che descrive il modello compartimentale e
% che ha come uscita la concentrazione di farmaco nel compartimento 3.

% tempo  espresso in ore 
% ingressi in mg/h
% volume del compartimento 3 in cc
% x1, x2, x3 massa in mg di farmaco nei 3 compartimenti 


% x1_dot=u1-(k12+k13)x1
% 
% x2_dot=u2+k12x1-k23x2
% 
% x3_dot=k13x1+k23x2-k3x3
% 
% y = 1/V3 * x3

% parametri nominali 
p.k12=0.5;
p.k13=0.5;
p.k3=0.5;
p.V3=2;
%k23 parametrico

%% punto2) 
% Si ponga k23 = 0. Si utilizzi MatLab per calcolare la matrice di osservabilit`a e si verifichi che il
% sistema `e non osservabile.
disp('Es. 2')

p1=p;
p1.k23=0;
[A, B, C, D] = get_matrix_model(p1);

Mo_aut=obsv(A,C) %calcolata utilizzando funzione matlab

Mo_man=[C;
        C*A;
        C*A^2]  %calcolata utilizzando formula

    
if rank(Mo_aut)==size(A,1)
    disp('sistema osservabile con k23='+string(p1.k23))
else
    disp('sistema non osservabile con k23='+string(p1.k23))
end

keyboard

%% punto3) 
%Si ponga k23 = 0.5 e si verifichi usando MatLab che il sistema `e ancora non osservabile. Si verifichi
% che, dato un qualunque ? ? R, lo stato iniziale x(0) = [?? ? 0]> genera un movimento libero di
% uscita identicamente nullo

disp('Es. 3')
p3=p;
p3.k23=0.5;
[A, B, C, D] = get_matrix_model(p3);

Mo_aut=obsv(A,C)

if rank(Mo_aut)==size(A,1)
    disp('sistema osservabile con k23='+string(p3.k23))
else
    disp('sistema non osservabile con k23='+string(p3.k23))
end

% xl=e^(At)x0;
% yl=Ce^(At)x0;
figure
sist=ss(A,B,C,D);
for i=1:20
    alpha=i;
    x0=[-alpha,alpha,0]';
    [y,t,x] = initial(sist,x0);

    
    plot(t,y,'LineWidt',3)
    hold on
end
title('Simulazioni con \alpha differenti')
keyboard

%% punto 4)
%Per k23 = 0.5 si determini usando MatLab se il sistema `e raggiungibile.
disp('Es. 4')
Mr_man=[B, A*B, A^2*B] %calcolata utilizzando formula

Mr_aut=ctrb(A,B) %calcolata utilizzando funzione matlab

if rank(Mr_aut)==size(A,1)
    disp('sistema raggiungibile con k23='+string(p3.k23))
else
    disp('sistema non raggiungibile con k23='+string(p3.k23))
end

keyboard

%% punto 5)
% Per k23 = 0.5 determinare (a mano) la quantit`a di farmaco da iniettare in vena attraverso una flebo
% (somministrazione continua e costante) in modo che, asintoticamente, la concentrazione di farmaco
% nel compartimento intestinale sia 0.5 mg/cc. Verificare il risultato in simulazione, partendo dallo
% stato iniziale x(0) = [0.5 0.5 0.2] (durata della simulazione: 20 sec.).

% simulo risposta a flebo con parametri p3
if sum(real(eig(A))<0)==size(A,1)
    GS=dcgain(sist);
    y_obiettivo=0.5; 
    u_2_bar=y_obiettivo/GS(2);
end

x0=[0.5 0.5 0.2]';

t_vector=0:0.1:20;
u_vector=[zeros(length(t_vector),1), u_2_bar*ones(length(t_vector),1)];
[y_vector,t_out_vector,x_vector]=lsim(sist,u_vector,t_vector,x0);

figure 
plot(t_out_vector, y_vector,'LineWidth',5)
hold on
plot(t_out_vector, y_obiettivo*ones(length(t_out_vector),1),'--','LineWidth',5)
title('Risposta a flebo')


% provo ad applicare lo stesso input a modello con parametri diversi e vedo
% cosa succede, non mi aspetto di raggiungere l'uscita di riferimento 
% simulo risposta a flebo con parametri p1

[A, B, C, D] = get_matrix_model(p1);

sist=ss(A,B,C,D);
t_vector=0:0.1:20;
u_vector=[zeros(length(t_vector),1), u_2_bar*ones(length(t_vector),1)];
[y_vector,t_out_vector,x_vector]=lsim(sist,u_vector,t_vector,x0);

figure 
plot(t_out_vector, y_vector,'LineWidth',5)
hold on
plot(t_out_vector, y_obiettivo*ones(length(t_out_vector),1),'--','LineWidth',5)
title('Risposta a flebo con parametri diversi')

